/* Run like this: `echo MISSISSIPI | make run` */

#include <stdio.h>
#include <stdlib.h>

int n = 0; // the length of S
char *S = NULL; // the string of bytes specified on stdin

// Read all of stdin (until EOF) into S
void readall() {
    int rv;
    int maxn = 0;

    n = 0;
    do {
        if (n >= maxn) {
            maxn = maxn ? 4*maxn : 4096;
            S = S ? realloc(S, maxn) : malloc(maxn);
            if (!S) {
                perror("alloc");
                exit(1);
            }
        }
        rv = read(0, S+n, maxn-n);
        if (rv < 0) {
            perror("read");
            exit(1);
        }
        n += rv;
    } while (rv > 0);
}

// Write S[i..i+k-1] to stdout
void writesubstr(int i, int k) {
    int rv;

    while (k > 0) {
        rv = write(1, S+i, k);
        if (rv < 0) {
            perror("write");
            exit(1);
        }
        i += rv;
        k -= rv;
    }
}

// Write a blank line to stderr.
// This makes it easier to run the program from the command
// line and view the output.
// NOTE: Don't add any newlines to stdout;
// otherwise, the program will fail the auto-grading tests!!
void blankline() {
    fprintf(stderr, "\n");
}

int main(int argc, char **argv) {
    int i, j, k, bestk, besti;

    readall();

    // Naive algorithm to find the longest substring that's repeated in S
    bestk = 0; besti = 0;
    for (i=0; i<n; i++)
        for (j=i+1; j<n; j++)
            for (k=1; k<n-j+1; k++)
                if (memcmp(S+i, S+j, k) == 0 && k > bestk) {
                    bestk = k; besti = i;
                }
    
    writesubstr(besti, bestk);
    blankline();

    return 0;
}
